package com.warewms.config;

import com.jfinal.plugin.activerecord.ActiveRecordPlugin;
import com.jfinal.plugin.activerecord.dialect.MysqlDialect;
import com.jfinal.template.source.ClassPathSourceFactory;
import com.warewms.model.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import javax.sql.DataSource;

@Component
public class ActiveRecordConfig {

    // 由于spring中已经注入了DruidDataSource这里直接拿
    @Autowired
    private DataSource ds;

    @Bean(initMethod="start", destroyMethod="stop",name = "activeRecordPlugin")
    public ActiveRecordPlugin init() {
        ActiveRecordPlugin arp = new ActiveRecordPlugin(ds);
        arp.addSqlTemplate("sql/all.sql");
        arp.getEngine().setSourceFactory(new ClassPathSourceFactory());
        arp.setShowSql(false);
        _MappingKit.mapping(arp);
        return arp;
    }
}
