package com.warewms.thread;

import com.warewms.common.utils.R;
import com.warewms.common.utils.SpringContextUtils;
import com.warewms.form.BtnOpForm;
import com.warewms.service.BtnService;
import com.warewms.utils.WcsTransitionUtils;
import lombok.extern.slf4j.Slf4j;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;

@Slf4j
public class ReadClientDataThread implements Runnable {

    private InputStream is = null;
    private OutputStream os = null;
    private String ipHome = null;

    public ReadClientDataThread(Socket socket) {
        try {
            InetAddress address = socket.getInetAddress();
            ipHome = address.getHostAddress();
            is = socket.getInputStream();
            os = socket.getOutputStream();
        } catch (IOException e) {
            System.out.println("获取已连接会话中的输入流出现了错误：\n");
            e.printStackTrace();
        }
    }

    @Override
    public void run() {
        try {
            int len = 0;
            byte[] bytes = new byte[10];
            String temp = null;
            WcsTransitionUtils wcsTransitionUtils = new WcsTransitionUtils();
            BtnService buttonTaskService = (BtnService) SpringContextUtils.getBean("btnServiceImpl");//注入ben
            R r = new R();

            while ((len = is.read(bytes)) != -1) {
                log.info("________________");
                log.info("客户端地址：" + ipHome);
                log.info("________________");
                try {
                    //02EACDF2CDF2CBEA0202
                    //CBEACDF2CDF2CBEA0202
                    //请求参数
                    BtnOpForm btnOpForm = new BtnOpForm();
                    btnOpForm.setIp(ipHome);
                    String orderText = wcsTransitionUtils.bytesToHexString(bytes).replace(" ", "");
                    //System.out.println(orderText);
                    if (orderText.equals("2A0163030203016D2424")) {
                        btnOpForm.setOpType("CLOSE");
                        buttonTaskService.opBtn(btnOpForm);
                        log.info("控制-------------------》");
                    } else if (orderText.equals("2A0163030204016E2424")) {
                        btnOpForm.setOpType("OPEN");
                        buttonTaskService.opBtn(btnOpForm);
                        log.info("解除控制-------------------》");
                    } else {
                        //log.info("过滤无效的指令");
                    }
                } catch (Exception e) {
                    log.error("调用接口下达任务出现异常-异常原因如下：");
                    log.error(e.getMessage());
                    e.printStackTrace();
                }
            }

        } catch (Exception e) {
            log.error("读取按钮盒信息失败");
            log.error(e.getMessage());
            // e.printStackTrace();
        }
    }
}
